package sun.misc;

import java.io.PrintStream;
import java.io.IOException;
import java.io.OutputStream;

public class UUEncoder extends CharacterEncoder
{
    private String bufferName;
    private int mode;
    
    public UUEncoder() {
        this.bufferName = "encoder.buf";
        this.mode = 644;
    }
    
    public UUEncoder(String bufferName) {
        this.bufferName = bufferName;
        this.mode = 644;
    }
    
    public UUEncoder(String bufferName, int mode) {
        this.bufferName = bufferName;
        this.mode = mode;
    }
    
    @Override
    protected int bytesPerAtom() {
        return 3;
    }
    
    @Override
    protected int bytesPerLine() {
        return 45;
    }
    
    @Override
    protected void encodeAtom(OutputStream outputStream, byte[] array, int n, int n2) throws IOException {
        int n3 = 1;
        int n4 = 1;
        int n5 = array[n];
        if (n2 > 1) {
            n3 = array[n + 1];
        }
        if (n2 > 2) {
            n4 = array[n + 2];
        }
        int n6 = n5 >>> 2 & 0x3F;
        int n7 = (n5 << 4 & 0x30) | (n3 >>> 4 & 0xF);
        int n8 = (n3 << 2 & 0x3C) | (n4 >>> 6 & 0x3);
        int n9 = n4 & 0x3F;
        outputStream.write(n6 + 32);
        outputStream.write(n7 + 32);
        outputStream.write(n8 + 32);
        outputStream.write(n9 + 32);
    }
    
    @Override
    protected void encodeLinePrefix(OutputStream outputStream, int n) throws IOException {
        outputStream.write((n & 0x3F) + 32);
    }
    
    @Override
    protected void encodeLineSuffix(OutputStream outputStream) throws IOException {
        this.pStream.println();
    }
    
    @Override
    protected void encodeBufferPrefix(OutputStream out) throws IOException {
        (super.pStream = new PrintStream(out)).print("begin " + this.mode + " ");
        if (this.bufferName != null) {
            super.pStream.println(this.bufferName);
        }
        else {
            super.pStream.println("encoder.bin");
        }
        super.pStream.flush();
    }
    
    @Override
    protected void encodeBufferSuffix(OutputStream outputStream) throws IOException {
        super.pStream.println(" \nend");
        super.pStream.flush();
    }
}
